Index: test/edu/ucsb/nceas/metacat/dataone/MetadataTypeRegisterTest.java
===================================================================
--- test/edu/ucsb/nceas/metacat/dataone/MetadataTypeRegisterTest.java	(revision 6123)
+++ test/edu/ucsb/nceas/metacat/dataone/MetadataTypeRegisterTest.java	(revision 6124)
@@ -28,6 +28,8 @@
 import junit.framework.Test;
 import junit.framework.TestSuite;
 
+import org.dataone.client.ObjectFormatCache;
+import org.dataone.service.exceptions.NotFound;
 import org.dataone.service.types.*;
 
 /**
@@ -76,22 +78,36 @@
      */
     public void testIsMetadataType()
     {
-        ObjectFormat of = ObjectFormat.convert("XXXX");
+      ObjectFormat of = null;
+      try {
+	        of = ObjectFormatCache.getFormat("XXXX");
+              
+      } catch (NotFound e) {
         assertFalse(MetadataTypeRegister.isMetadataType(of));
-        
-        of = ObjectFormat.convert("eml://ecoinformatics.org/eml-2.0.0");
-        assertTrue(MetadataTypeRegister.isMetadataType(of));
-        
-        of = ObjectFormat.convert("http://www.unidata.ucar.edu/namespaces/netcdf/ncml-2.2");
-        assertTrue(MetadataTypeRegister.isMetadataType(of));
-        
-        of = ObjectFormat.convert("CF-1.3");
-        assertTrue(MetadataTypeRegister.isMetadataType(of));
-        
-        of = ObjectFormat.convert("http://www.loc.gov/METS/");
-        assertTrue(MetadataTypeRegister.isMetadataType(of));
-        
-        of = ObjectFormat.convert("eml://ecoinformatics.org/eml-3.0.0");
-        assertFalse(MetadataTypeRegister.isMetadataType(of));
+      
+      }
+      
+      try {
+	      
+      	of = ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.0.0");
+	      assertTrue(MetadataTypeRegister.isMetadataType(of));
+	      
+	      of = ObjectFormatCache.getFormat("http://www.unidata.ucar.edu/namespaces/netcdf/ncml-2.2");
+	      assertTrue(MetadataTypeRegister.isMetadataType(of));
+	      
+	      of = ObjectFormatCache.getFormat("CF-1.3");
+	      assertTrue(MetadataTypeRegister.isMetadataType(of));
+	      
+	      of = ObjectFormatCache.getFormat("http://www.loc.gov/METS/");
+	      assertTrue(MetadataTypeRegister.isMetadataType(of));
+	      
+	      of = ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-3.0.0");
+	      assertFalse(MetadataTypeRegister.isMetadataType(of));
+      
+      } catch (NotFound e) {
+      	e.printStackTrace();
+      	
+      }
+
     }
 }
Index: test/edu/ucsb/nceas/metacat/dataone/CNCoreTest.java
===================================================================
--- test/edu/ucsb/nceas/metacat/dataone/CNCoreTest.java	(revision 6123)
+++ test/edu/ucsb/nceas/metacat/dataone/CNCoreTest.java	(revision 6124)
@@ -30,6 +30,7 @@
 import junit.framework.Test;
 import junit.framework.TestSuite;
 
+import org.dataone.client.ObjectFormatCache;
 import org.dataone.service.types.Checksum;
 import org.dataone.service.types.ChecksumAlgorithm;
 import org.dataone.service.types.Identifier;
@@ -125,7 +126,7 @@
 	    SystemMetadata sm = new SystemMetadata();
         //set the id
         sm.setIdentifier(id);
-        sm.setObjectFormat(ObjectFormat.OCTET_STREAM);
+        sm.setObjectFormat(ObjectFormatCache.getFormat("application/octet-stream"));
         //create the checksum
         String checksumS = "test";
         ChecksumAlgorithm ca = ChecksumAlgorithm.convert("MD5");
Index: test/edu/ucsb/nceas/metacat/dataone/CrudServiceTest.java
===================================================================
--- test/edu/ucsb/nceas/metacat/dataone/CrudServiceTest.java	(revision 6123)
+++ test/edu/ucsb/nceas/metacat/dataone/CrudServiceTest.java	(revision 6124)
@@ -34,6 +34,7 @@
 import junit.framework.TestSuite;
 
 import org.apache.commons.io.IOUtils;
+import org.dataone.client.ObjectFormatCache;
 import org.dataone.service.exceptions.BaseException;
 import org.dataone.service.types.AuthToken;
 import org.dataone.service.types.Checksum;
@@ -131,7 +132,7 @@
             //create the system metadata then run the create method
             StringBufferInputStream sbis = new StringBufferInputStream(testDoc);
             SystemMetadata sm = createSystemMetadata(id, testDoc, 
-                    ObjectFormat.convert("eml://ecoinformatics.org/eml-2.1.0"));
+                    ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.1.0"));
             //create the doc
             Identifier rGuid = cs.create(token, id, sbis, sm);
             
@@ -291,7 +292,7 @@
 	            id.setValue(docid);
 	            String testDoc = getTestDoc();
 	            StringBufferInputStream sbis = new StringBufferInputStream(testDoc);
-	            ObjectFormat of1 = ObjectFormat.convert("eml://ecoinformatics.org/eml-2.1.0");
+	            ObjectFormat of1 = ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.1.0");
 	            SystemMetadata sm = createSystemMetadata(id, testDoc, of1);
 	            assertFalse(sm.getChecksum().getValue().startsWith("MD5"));
 	            //create the doc
@@ -310,7 +311,7 @@
             id.setValue(docid);
             String testDoc = getTestDoc();
             StringBufferInputStream sbis = new StringBufferInputStream(testDoc);
-            ObjectFormat of1 = ObjectFormat.convert("eml://ecoinformatics.org/eml-2.1.0");
+            ObjectFormat of1 = ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.1.0");
             SystemMetadata sm = createSystemMetadata(id, testDoc, of1);
             assertFalse(sm.getChecksum().getValue().startsWith("MD5"));
             //create the doc
@@ -358,7 +359,7 @@
 	        Date d1 = new Date(new Date().getTime() - 5000);
 	        CrudService cs = CrudService.getInstance();
 	        AuthToken token = getToken();
-	        ObjectFormat of1 = ObjectFormat.convert("eml://ecoinformatics.org/eml-2.1.0");
+	        ObjectFormat of1 = ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.1.0");
 	        //create docs at different times
 
 	        Identifier id = new Identifier();
@@ -479,8 +480,8 @@
 	    {
 	        CrudService cs = CrudService.getInstance();
 	        AuthToken token = getToken();
-	        ObjectFormat of1 = ObjectFormat.convert("eml://ecoinformatics.org/eml-2.1.0");
-	        ObjectFormat of2 = ObjectFormat.convert("eml://ecoinformatics.org/eml-2.0.0");
+	        ObjectFormat of1 = ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.1.0");
+	        ObjectFormat of2 = ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.0.0");
 	        //create docs at different times
 	        Date d1 = new Date();
 	        Identifier id1 = createDoc(token, getTestDoc(EML2_1_0), of1);
@@ -820,7 +821,7 @@
 	 */
 	public Identifier createDoc(AuthToken token, String testDoc) throws Exception
 	{
-	    return createDoc(token, testDoc, ObjectFormat.convert("eml://ecoinformatics.org/eml-2.1.0"));
+	    return createDoc(token, testDoc, ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.1.0"));
 	}
 	
 	/**
@@ -851,7 +852,7 @@
 	  throws Exception
 	{
 	    return createSystemMetadata(id, testDoc, 
-	            ObjectFormat.convert("eml://ecoinformatics.org/eml-2.1.0"));
+	            ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.1.0"));
 	}
 	
 	/**
Index: src/loaddtdschema-oracle.sql
===================================================================
--- src/loaddtdschema-oracle.sql	(revision 6123)
+++ src/loaddtdschema-oracle.sql	(revision 6124)
@@ -55,5 +55,9 @@
   VALUES ('Schema', 'http://dataone.org/service/types/0.5.1', '/schema/D1_SCHEMA_0_5_1/dataoneTypes.xsd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('Schema', 'http://ns.dataone.org/service/types/0.6.0', '/schema/D1_SCHEMA_0_6_0/dataoneTypes.xsd');  
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', 'http://ns.dataone.org/service/types/0.6.1', '/schema/D1_SCHEMA_0_6_1/dataoneTypes.xsd');  
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', 'http://ns.dataone.org/service/types/0.6.2', '/schema/D1_SCHEMA_0_6_2/dataoneTypes.xsd');  
 INSERT INTO db_version (version, status, date_created) 
   VALUES ('1.10.0',1,CURRENT_DATE);
Index: src/edu/ucsb/nceas/metacat/restservice/ResourceHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/restservice/ResourceHandler.java	(revision 6123)
+++ src/edu/ucsb/nceas/metacat/restservice/ResourceHandler.java	(revision 6124)
@@ -45,6 +45,7 @@
 import org.apache.log4j.Logger;
 import org.apache.maven.artifact.ant.shaded.IOUtil;
 import org.dataone.client.MNode;
+import org.dataone.client.ObjectFormatCache;
 import org.dataone.mimemultipart.MultipartRequest;
 import org.dataone.mimemultipart.MultipartRequestResolver;
 import org.dataone.service.NodeListParser;
@@ -538,7 +539,7 @@
                             if(params.containsKey("format"))
                             {
                                 String format = params.get("format")[0];
-                                of = ObjectFormat.convert(format);
+                                of = ObjectFormatCache.getFormat(format);
                             }
                             if(params.containsKey("time"))
                             {
@@ -575,7 +576,7 @@
                             if(params.containsKey("format"))
                             {
                                 String format = params.get("format")[0];
-                                of = ObjectFormat.convert(format);
+                                of = ObjectFormatCache.getFormat(format);
                             }
                             if(params.containsKey("eventtime"))
                             {
@@ -1164,17 +1165,20 @@
                     SystemMetadata sm = cs.getSystemMetadata(token, id);
                     
                     //set the content type
-                    if(sm.getObjectFormat().toString().trim().equals(ObjectFormat.TEXT_CSV.toString()))
+                    if(sm.getObjectFormat().toString().trim().equals(
+                    		ObjectFormatCache.getFormat("text/csv").getFmtid().getValue()))
                     {
                         response.setContentType("text/csv");
                         response.setHeader("Content-Disposition", "inline; filename=" + id.getValue() + ".csv");
                     }
-                    else if(sm.getObjectFormat().toString().trim().equals(ObjectFormat.TEXT_PLAIN.toString()))
+                    else if(sm.getObjectFormat().toString().trim().equals(
+                    		ObjectFormatCache.getFormat("text/plain").getFmtid().getValue()))
                     {
                         response.setContentType("text/plain");
                         response.setHeader("Content-Disposition", "inline; filename=" + id.getValue() + ".txt");
                     } 
-                    else if(sm.getObjectFormat().toString().trim().equals(ObjectFormat.OCTET_STREAM.toString()))
+                    else if(sm.getObjectFormat().toString().trim().equals(
+                    		ObjectFormatCache.getFormat("application/octet-stream").getFmtid().getValue()))
                     {
                         response.setContentType("application/octet-stream");
                     }
@@ -1271,7 +1275,7 @@
                     }
                     else if(name.equals("objectFormat") && value != null) 
                     {
-                        objectFormat = ObjectFormat.convert(value[0]);
+                        objectFormat = ObjectFormatCache.getFormat(value[0]);
                     }
                     else if(name.equals("replicaStatus") && value != null)
                     {
Index: src/edu/ucsb/nceas/metacat/MetaCatServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 6123)
+++ src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 6124)
@@ -345,7 +345,7 @@
 			ServiceService.registerService("XMLSchemaService", XMLSchemaService.getInstance());
 			
 			// register the object format service
-      //ServiceService.registerService("ObjectFormatService", ObjectFormatService.getInstance());
+      ServiceService.registerService("ObjectFormatService", ObjectFormatService.getInstance());
 
 			// check if eml201 document were corrected or not. if not, correct eml201 documents.
 			// Before Metacat 1.8.1, metacat uses tag RELEASE_EML_2_0_1_UPDATE_6 as eml
Index: src/edu/ucsb/nceas/metacat/MetacatHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetacatHandler.java	(revision 6123)
+++ src/edu/ucsb/nceas/metacat/MetacatHandler.java	(revision 6124)
@@ -112,6 +112,7 @@
 import org.apache.log4j.Logger;
 import org.ecoinformatics.eml.EMLParser;
 
+import org.dataone.client.ObjectFormatCache;
 import org.dataone.eml.DataoneEMLParser;
 import org.dataone.eml.EMLDocument;
 import org.dataone.eml.EMLDocument.DistributionMetadata;
@@ -3588,23 +3589,40 @@
       Hashtable<String, Object> docInfo = IdentifierManager.getInstance().getDocumentInfo(localId);
       //set the default object format
       String doctype = (String) docInfo.get("doctype");
-      ObjectFormat format = ObjectFormat.convert(doctype);
-      if (format == null) {
-          if (doctype.trim().equals("BIN")) {
-              format = ObjectFormat.OCTET_STREAM;
-          } else {
-              format = ObjectFormat.convert("text/plain");
-          }
+      ObjectFormat format = null;
+      
+      // set the object format, fall back to defaults
+      try {
+	      format = ObjectFormatCache.getFormat(doctype);
+
+      } catch (NotFound nfe) {
+        
+        try {
+        	// format is not registered, use default
+	        if (doctype.trim().equals("BIN")) {
+	        	format = ObjectFormatCache.getFormat("application/octet-stream");
+	        
+	        } else {
+	        	format = ObjectFormatCache.getFormat("text/plain");
+	        }
+        
+        } catch (NotFound nf) {
+          logMetacat.error("There was a problem getting the default format " +
+          	"from the ObjectFormatCache: " + nf.getMessage());
+          throw nf;
+        }
+
       }
+      
       sysMeta.setObjectFormat(format);
       logMetacat.debug("The ObjectFormat for " + localId + " is " + format.toString());
       
       // further parse EML documents to get data object format,
       // describes and describedBy information
-      if ( format == ObjectFormat.EML_2_0_0 ||
-           format == ObjectFormat.EML_2_0_1 ||
-           format == ObjectFormat.EML_2_1_0 ||
-           format == ObjectFormat.EML_2_1_1 ) {
+      if ( format == ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.0.0") ||
+           format == ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.0.1") ||
+           format == ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.1.0") ||
+           format == ObjectFormatCache.getFormat("eml://ecoinformatics.org/eml-2.1.1") ) {
         
         try {
           DataoneEMLParser emlParser = DataoneEMLParser.getInstance();
@@ -3622,7 +3640,8 @@
             String dataDocUrl = distMetadata.url;
             String dataDocMimeType = "";
             if (distMetadata.mimeType == null) {
-                dataDocMimeType = ObjectFormat.OCTET_STREAM.name();
+                dataDocMimeType = 
+                	ObjectFormatCache.getFormat("application/octet-stream").getFmtid().getValue();
             } else {
                 dataDocMimeType = distMetadata.mimeType;
             }
@@ -3670,9 +3689,9 @@
                       
                       // set object format
                       logMetacat.debug("Updating system metadata for " + dataGuid.getValue() + " to " + dataDocMimeType);
-                      ObjectFormat f = ObjectFormat.convert(dataDocMimeType);
+                      ObjectFormat f = ObjectFormatCache.getFormat(dataDocMimeType);
                       if (f == null) {
-                    	  f = ObjectFormat.OCTET_STREAM;
+                    	  f = ObjectFormatCache.getFormat("application/octet-stream");
                       }
                       dataSysMeta.setObjectFormat(f);
                   
Index: src/edu/ucsb/nceas/metacat/service/ObjectFormatService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/service/ObjectFormatService.java	(revision 6123)
+++ src/edu/ucsb/nceas/metacat/service/ObjectFormatService.java	(revision 6124)
@@ -48,6 +48,7 @@
 
 import org.dataone.client.CNode;
 import org.dataone.client.D1Client;
+import org.dataone.client.ObjectFormatCache;
 import org.dataone.service.exceptions.InsufficientResources;
 import org.dataone.service.exceptions.InvalidRequest;
 import org.dataone.service.exceptions.NotFound;
@@ -55,6 +56,7 @@
 import org.dataone.service.exceptions.ServiceFailure;
 import org.dataone.service.types.Identifier;
 import org.dataone.service.types.ObjectFormat;
+import org.dataone.service.types.ObjectFormatList;
 //import org.dataone.service.types.ObjectFormatList;
 import org.dataone.service.types.util.ServiceTypeUtil;
 import org.jibx.runtime.JiBXException;
@@ -87,7 +89,7 @@
   private String accNumber = null;
 
   /* The list of object formats */
-  //private static ObjectFormatList objectFormatList = null;
+  private static ObjectFormatList objectFormatList = null;
   
   /* the searchable map of object formats */
   private static HashMap<String, ObjectFormat> objectFormatMap = 
@@ -182,82 +184,7 @@
       throw new ServiceException(message);
     }
     
-    // For DataONE Member Nodes, get the authoritative list from the 
-    // Coordinating Node, otherwise, get the cached list
-    if ( this.nodeType.equals("mn") ) {
-      
-      /*
-       *try {
-       *  
-       *  // try to get the authoritative list remotely
-       *  D1Client d1Client = new D1Client(coordinatingNodeBaseURL);
-       *  this.cn = D1Client.getCN();
-       *  this.objectFormatList = cn.listFormats();
-       *
-       *} catch (ServiceFailure e) {
-       *  
-       *  logMetacat.debug("There was a getting the object format list from " +
-       *    "the coordinating node. The message was: " +
-       *    e.getMessage());
-       *  this.getCachedList();  
-       *  
-       *} catch (NotImplemented e) {
-       *  
-       *  logMetacat.debug("There was a getting the object format list from " +
-       *    "the coordinating node. The message was: " + e.getMessage());
-       *  this.getCachedList();  
-       *  
-       *} catch (InvalidRequest e) {
-       *  
-       *  logMetacat.debug("There was a getting the object format list from " +
-       *    "the coordinating node. The message was: " + e.getMessage());
-       *  this.getCachedList();  
-       *  
-       *} catch (NotFound e) {
-       *  
-       *  logMetacat.debug("There was a getting the object format list from " +
-       *    "the coordinating node. The message was: " + e.getMessage());
-       *  this.getCachedList();  
-       *  
-       *} catch (InsufficientResources e) {
-       *  
-       *  logMetacat.debug("There was a getting the object format list from " +
-       *    "the coordinating node. The message was: " + e.getMessage());
-       *  this.getCachedList();  
-       *  
-       *}
-       */
-      
-      // this will be replaced with external lookup code above
-      //this.getCachedList();
-      
-    } else if ( this.nodeType.equals("cn") ) {
-      
-      // get the list from the local metacat database
-      //this.getCachedList();  
-
-    } else {
-      
-      // the node type is not recognized
-      throw new ServiceException("An error occurred in initializing the " +
-        "ObjectFormatService. The DataONE node type needs to be either "  +
-        "'cn' or 'mn', but instead was: " + this.nodeType);
-    }
-    
-    // index the object format list based on the format identifier
-    //int listSize = ObjectFormatService.objectFormatList.sizeObjectFormats();
-    //
-    //for (int i = 0; i < listSize; i++ ) {
-    //  
-    //  ObjectFormat objectFormat = 
-    //    ObjectFormatService.objectFormatList.getObjectFormat(i);
-    //  String identifier = objectFormat.getFmtid();
-    //  ObjectFormatService.objectFormatMap.put(identifier, objectFormat);
-    //  
-    //}
-        
-
-    
+    this.getCachedList();  
   }
 
   /**
@@ -287,11 +214,11 @@
    * 
    * @return objectFormatList - the list of object formats
    */
-  //public ObjectFormatList listFormats() {
-  //  
-  //  return ObjectFormatService.objectFormatList;
-  //  
-  //}
+  public ObjectFormatList listFormats() {
+    
+    return ObjectFormatService.objectFormatList;
+    
+  }
   
   /**
    * Get the object format based on the given identifier as a string.
@@ -299,14 +226,14 @@
    * @param format - the object format as a string
    * @return objectFormat - the ObjectFormat represented by the format string
    */
-  //public static ObjectFormat getFormat(String format) {
-  //  
-  //  ObjectFormat objectFormat = null;
-  //  objectFormat = ObjectFormatService.objectFormatMap.get(format);
-  //  
-  //  return objectFormat;
-  //  
-  //}
+  public static ObjectFormat getFormat(String format) {
+    
+    ObjectFormat objectFormat = null;
+    objectFormat = ObjectFormatService.objectFormatMap.get(format);
+    
+    return objectFormat;
+    
+  }
   /**
    * Get the object format list cached in Metacat, or on failure, via a
    * cached file on disk
@@ -313,140 +240,74 @@
    * 
    * @return objectFormatList - the cached object format list
    */
-  //private void getCachedList()
-  //  throws ServiceException {
-  //        
-  //  try {
-  //    
-  //    // reset the accession number separator in case it is 
-  //    // different than the default
-  //    try {
-  //      
-  //      this.separator = PropertyService.getProperty("document.accNumSeparator");
-  //      
-  //    } catch ( PropertyNotFoundException pnfe ) {
-  //      
-  //      // use the default separator, but log the issue
-  //      logMetacat.debug("There was a problem finding the document " +
-  //        "separator property. The error message was: " + pnfe.getMessage());
-  //    }
-  //    
-  //    // get the latest accession number if it is in Metacat
-  //    this.rev = 
-  //      DBUtil.getLatestRevisionInDocumentTable(this.OBJECT_FORMAT_DOCID);
-  //    
-  //    if ( this.rev != -1 ) {
-  //      this.accNumber = this.OBJECT_FORMAT_DOCID + 
-  //                       this.separator + 
-  //                       this.rev;
-  //      DocumentImpl objectFormatsDocument = new DocumentImpl(accNumber, false);
-  //      ByteArrayInputStream bais = 
-  //        new ByteArrayInputStream(objectFormatsDocument.toString().getBytes());
-  //      ObjectFormatService.objectFormatList = 
-  //        this.deserializeObjectFormatList(bais);
-  //
-  //    } else {
-  //      
-  //      logMetacat.info("The latest revision number of "   + 
-  //        this.OBJECT_FORMAT_DOCID                         +
-  //        " could not be found. Reverting to the on-disk " +
-  //        "object format list");
-  //      try {
-  //        
-  //        ObjectFormatService.objectFormatList = this.getListFromDisk();
-  //      
-  //      } catch (ServiceException se) {
-  //        
-  //        throw new ServiceException(se.getMessage());
-  //      
-  //      }
-  //
-  //    }
-  //    
-  //  } catch ( SQLException sqle ) {
-  //    
-  //    // we either have a metacat error or the docid was not inserted yet
-  //    logMetacat.info("The latest revision number of "   + 
-  //      this.OBJECT_FORMAT_DOCID                         +
-  //      " could not be found. Reverting to the on-disk " +
-  //      "object format list");
-  //    
-  //    try {
-  //      
-  //      ObjectFormatService.objectFormatList = this.getListFromDisk();
-  //    
-  //    } catch (ServiceException se) {
-  //      
-  //      throw se; 
-  //      
-  //    }
-  //    
-  //  } catch (McdbException mcdbe) {
-  //    
-  //    // we have a metacat doc not found error
-  //    logMetacat.info( this.OBJECT_FORMAT_DOCID          +
-  //      " could not be found. Reverting to the on-disk " +
-  //      "object format list");
-  //    
-  //    try {
-  //      
-  //      ObjectFormatService.objectFormatList = this.getListFromDisk();
-  //    
-  //    } catch (ServiceException se) {
-  //      
-  //      throw se; 
-  //      
-  //    }
-  //    
-  //
-  //  }
-  //
-  //  return;
-  //  
-  //}
+  private void getCachedList()
+    throws ServiceException {
+          
+    try {
+      
+      // reset the accession number separator in case it is 
+      // different than the default
+      try {
+        
+        this.separator = PropertyService.getProperty("document.accNumSeparator");
+        
+      } catch ( PropertyNotFoundException pnfe ) {
+        
+        // use the default separator, but log the issue
+        logMetacat.debug("There was a problem finding the document " +
+          "separator property. The error message was: " + pnfe.getMessage());
+      }
+      
+      // get the latest accession number if it is in Metacat
+      this.rev = 
+        DBUtil.getLatestRevisionInDocumentTable(this.OBJECT_FORMAT_DOCID);
+      
+      if ( this.rev != -1 ) {
+        this.accNumber = this.OBJECT_FORMAT_DOCID + 
+                         this.separator + 
+                         this.rev;
+        DocumentImpl objectFormatsDocument = new DocumentImpl(accNumber, false);
+        ByteArrayInputStream bais = 
+          new ByteArrayInputStream(objectFormatsDocument.toString().getBytes());
+        ObjectFormatService.objectFormatList = 
+          this.deserializeObjectFormatList(bais);
+  
+      } else {
+        
+        logMetacat.info("The latest revision number of "   + 
+          this.OBJECT_FORMAT_DOCID                         +
+          " could not be found. Reverting to the on-disk " +
+          "object format list");
+          
+        ObjectFormatService.objectFormatList = ObjectFormatCache.listFormats();
+      }
+      
+    } catch ( SQLException sqle ) {
+      
+      // we either have a metacat error or the docid was not inserted yet
+      logMetacat.info("The latest revision number of "   + 
+        this.OBJECT_FORMAT_DOCID                         +
+        " could not be found. Reverting to the on-disk " +
+        "object format list");
+        
+      ObjectFormatService.objectFormatList = ObjectFormatCache.listFormats();
+      
+    } catch (McdbException mcdbe) {
+      
+      // we have a metacat doc not found error
+      logMetacat.info( this.OBJECT_FORMAT_DOCID          +
+        " could not be found. Reverting to the on-disk " +
+        "object format list");
+      
+      ObjectFormatService.objectFormatList = ObjectFormatCache.listFormats();
+  
+    }
+  
+    return;
+    
+  }
 
   /**
-   * Get the object format list cached on disk as stated in the metacat
-   * properties file.
-   * 
-   * @return objectFormatList - the on-disk object format list
-   * @throws ServiceException
-   */
-  //private ObjectFormatList getListFromDisk() 
-  //  throws ServiceException {
-  //  
-  //  // the filesystem location of the object format list xml file
-  //  String objectFormatFilePath = null;
-  //  
-  //  // get the object format list from disk and parse it
-  //  try {
-  //    objectFormatFilePath = SystemUtil.getContextDir() + "/WEB-INF/" +
-  //      PropertyService.getProperty("dataone.objectFormatListName");
-  //          
-  //    FileInputStream fileInputStream = new FileInputStream(objectFormatFilePath);         
-  //
-  //    ObjectFormatService.objectFormatList = 
-  //      this.deserializeObjectFormatList(fileInputStream);
-  //
-  //  } catch (PropertyNotFoundException pnfe) {
-  //    
-  //    logMetacat.error("The object format list file could not be parsed. " +
-  //      "The error message was: " + pnfe.getMessage());
-  //    throw new ServiceException(pnfe.getMessage());
-  //    
-  //  } catch ( FileNotFoundException fnfe ) {
-  //    
-  //    logMetacat.debug("There was an error reading the file " +
-  //      objectFormatFilePath + ". The error was: "            +
-  //      fnfe.getMessage());
-  //    throw new ServiceException(fnfe.getMessage());
-  //        
-  //  }
-  //  
-  //  return ObjectFormatService.objectFormatList;
-  //}
-
-  /**
    * Deserialize the object format list file to an object format list object
    * 
    * @param fileInputStream - the file input stream of the XML object format list file
@@ -453,23 +314,23 @@
    * @return objectFormatList - the ObjectFormatList object from the XML stream
    * @throws ServiceException
    */
-  //private ObjectFormatList deserializeObjectFormatList(InputStream inputStream) 
-  //  throws ServiceException {
-  //  
-  //  ObjectFormatList objectFormatList;
-  //  try {
-  //    objectFormatList = (ObjectFormatList)
-  //    ServiceTypeUtil.deserializeServiceType(ObjectFormatList.class, inputStream);
-  //  
-  //  } catch ( JiBXException jbxe ) {
-  //    
-  //    logMetacat.debug("There was an error deserializing the input stream. " +
-  //      "The error was: " + jbxe.getMessage());
-  //    jbxe.printStackTrace();
-  //    throw new ServiceException(jbxe.getMessage());
-  //  }
-  //  
-  //  return objectFormatList;
-  //}
+  private ObjectFormatList deserializeObjectFormatList(InputStream inputStream) 
+    throws ServiceException {
+    
+    ObjectFormatList objectFormatList;
+    try {
+      objectFormatList = (ObjectFormatList)
+      ServiceTypeUtil.deserializeServiceType(ObjectFormatList.class, inputStream);
+    
+    } catch ( JiBXException jbxe ) {
+      
+      logMetacat.debug("There was an error deserializing the input stream. " +
+        "The error was: " + jbxe.getMessage());
+      jbxe.printStackTrace();
+      throw new ServiceException(jbxe.getMessage());
+    }
+    
+    return objectFormatList;
+  }
   
 }
\ No newline at end of file
